Improve comment and function regular expressions to reduce decision points.
[releases.git] / deblob-main
index 3d8d5f5192b01fa64cb7ff473659ec20e9ba5d35..2d70577076cc8ad40ce77eb5a63fffe2efa1dec5 100755 (executable)
@@ -1,6 +1,6 @@
 #! /bin/sh
 
-# Copyright (C) 2008 Alexandre Oliva <lxoliva@fsfla.org>
+# Copyright (C) 2008, 2009 Alexandre Oliva <lxoliva@fsfla.org>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # USA
 
 # deblob.sh - prepare a linux-libre tarball out of a non-libre Linux
-# tarball.  It expects the Linux release (kver) as the first argument,
-# and the libre sub-release (extra) as the second optional argument.
+# tarball.  It expects the Linux release (mver, say 2.6.25) as the
+# first argument, the libre sub-release (extra) as the second optional
+# argument, and the patch release (sver, say .13) as an optional third
+# argument.  mver and sver are pasted together to form kver.
 
-# linux-$kver.tar.bz2 and deblob-$kver must exist in the current
-# directory, and the line that sets kver and extra in deblob-$kver
-# must match the command-line arguments.  
+# linux-$kver.tar.bz2 and deblob-$mver must exist in the current
+# directory, and the line that sets kver and extra in deblob-$mver
+# must match mver and extra.
 
 # The resulting tarball is put in linux-$kver-libre$extra.tar.bz2, and
 # an uncompressed xdelta that produces linux-$kver-libre$extra.tar out
@@ -42,7 +44,7 @@
 # At the end, the script attempts to generate a digital signature for
 # the newly-created tarball.  This is the last thing the script does,
 # so interrupting it at that point to skip the signing won't fail to
-# do anything else.  
+# do anything else.
 
 # It is safe to interrupt the script at any other point.  When it gets
 # a ^C (other than during signing), it starts cleaning up all of its
 # behind, and then it will refuse to run again before you clean it up
 # by hand.  It takes extra care to avoid overwriting useful files.
 
-kver=$1 extra=$2 libre=libre$extra
-deblob= dir=`echo $0 | sed 's,/[^/]*$,,'`
+# If deblob-$mver finds any unexpected situation, it will error out,
+# and then deblob-main will quit.  Pass --force to deblob-main, before
+# any other argument, for deblob-main to ignore any such situations.
+
+case $1 in
+--force) force=--force; shift;;
+*) force=;;
+esac
+
+mver=$1 extra=$2 sver=$3
+kver=$mver$sver libre=libre$extra
+deblob= dir=`echo "$0" | sed 's,[^/]*$,,;s,^$,.,;s,/*$,,'`
 
 if test ! -f linux-$kver.tar.bz2; then
   echo linux-$kver.tar.bz2 does not exist >&2
   exit 1
 fi
 
-if test -f deblob-$kver; then
-  deblob=deblob-$kver
+if test -f deblob-$mver; then
+  deblob=deblob-$mver
 elif test -f deblob; then
   deblob=deblob
-elif test -f $dir/deblob-$kver; then
-  cp $dir/deblob-$kver deblob
+elif test -f $dir/deblob-$mver; then
+  cp $dir/deblob-$mver deblob
   deblob=deblob
 else
   echo deblob does not exist >&2
   exit 1
 fi
 
-x1="kver=$kver extra=$extra"
-x2=`grep \"^$x1$\" $deblob`
-if test "$x1" != "$x2"; then
+x1="kver=$mver extra=$extra"
+x2=`grep "^kver=[^ ]* extra=" $deblob`
+if test "$x1" = "$x2"; then
   :
 else
   echo deblob script does not match command-line arguments >&2
@@ -81,45 +93,41 @@ else
   exit 1
 fi
 
-if test -f linux-$kver-$libre.tar.bz2; then
-  echo linux-$kver-$libre.tar.bz2 already exists >&2
-  exit 1
-fi
-
-if test -f linux-$kver.tar; then
-  echo linux-$kver.tar already exists >&2
-  exit 1
-fi
-
-if test -f linux-$kver-$libre.tar; then
-  echo linux-$kver-$libre.tar already exists >&2
-  exit 1
-fi
-
-if test -f linux-$kver-$libre.patch; then
-  echo linux-$kver-$libre.patch already exists >&2
-  exit 1
-fi
-
-if test -f linux-$kver-$libre.xdelta; then
-  echo linux-$kver-$libre.xdelta already exists >&2
-  exit 1
-fi
-
-if test -d linux-$kver; then
-  echo linux-$kver already exists >&2
-  exit 1
-fi
-
-if test -d linux-$kver-$libre; then
-  echo linux-$kver-$libre already exists >&2
-  exit 1
-fi
-
-if test -d orig-linux-$kver; then
-  echo orig-linux-$kver already exists >&2
-  exit 1
-fi
+cleanup=
+
+for f in \
+  linux-$kver-$libre.tar.bz2 \
+  linux-$kver-$libre.tar.bz2.asc \
+  linux-$kver-$libre.tar.bz2.sign \
+  linux-$kver-$libre.tar.lz \
+  linux-$kver-$libre.tar.lz.asc \
+  linux-$kver-$libre.tar.lz.sign \
+  linux-$kver.tar \
+  linux-$kver-$libre.tar \
+  linux-$kver-$libre.patch \
+  linux-$kver-$libre.log \
+  linux-$kver-$libre.xdelta \
+  linux-$kver-$libre.xdelta.asc \
+  linux-$kver-$libre.xdelta.sign \
+; do
+  if test -f $f; then
+    echo $f already exists >&2
+    exit 1
+  fi
+  cleanup="$cleanup $f"
+done
+
+for d in \
+  linux-$kver \
+  linux-$kver-$libre \
+  orig-linux-$kver \
+; do
+  if test -d $d; then
+    echo $d already exists >&2
+    exit 1
+  fi
+  cleanup="$cleanup $d"
+done
 
 if test -f $dir/deblob-$kver; then
   if cmp $dir/deblob-$kver $deblob; then
@@ -145,32 +153,47 @@ else
   fi
 fi
 
-trap "status=$?; echo cleaning up...; rm -rf orig-linux-$kver linux-$kver linux-$kver-$libre linux-$kver.tar linux-$kver-$libre.tar linux-$kver-$libre.tar.bz2 linux-$kver-$libre.patch linux-$kver-$libre.xdelta; (exit $status); exit" 0 1 2 15
+trap "status=$?; echo cleaning up...; rm -rf $cleanup; (exit $status); exit" 0 1 2 15
+
+set -e
 
 echo Uncompressing linux-$kver.tar.bz2 into linux-$kver.tar
 rm -rf linux-$kver linux-$kver.tar
 bunzip2 < linux-$kver.tar.bz2 > linux-$kver.tar
 
-echo Extracing linux-$kver.tar into linux-$kver
+echo Extracting linux-$kver.tar into linux-$kver
 tar -xf linux-$kver.tar
 rm -rf linux-$kver-$libre linux-$kver-$libre.tar
 
-echo Copying linux-$kver to linux-$kver-$libre.tar
+echo Copying linux-$kver to linux-$kver-$libre
 cp linux-$kver.tar linux-$kver-$libre.tar
 cp -lR linux-$kver/. linux-$kver-$libre
 
-echo Deblobbing within linux-$kver-$libre
-(cd linux-$kver-$libre && /bin/sh ../$deblob)
+rm -f linux-$kver-$libre.log linux-$kver-$libre.log.tmp
+echo Deblobbing within linux-$kver-$libre, saving output to linux-$kver-$libre.log
+# We can't just pipe deblob into tee, for then we fail to detect 
+# error conditions.  Use file renaming to tell whether we succeeded.
+if (cd linux-$kver-$libre && /bin/sh ../$deblob $force) 2>&1; then
+  mv linux-$kver-$libre.log.tmp linux-$kver-$libre.log
+fi | tee linux-$kver-$libre.log.tmp
+if test ! -f linux-$kver-$libre.log; then
+  mv linux-$kver-$libre.log.tmp linux-$kver-$libre.log
+  echo $deblob failed, aborting >&2
+  exit 1
+fi
 rm -f linux-$kver-$libre.patch
 
+# Do not copy these scripts for now, deblob-check regards itself as a blob.
+# cp -p $0 $deblob deblob-check linux-$kver-$libre
+
 echo Generating linux-$kver-$libre.patch
-diff -druN linux-$kver linux-$kver-$libre > linux-$kver-$libre.patch
+diff -druN linux-$kver linux-$kver-$libre > linux-$kver-$libre.patch || :
 
 echo Removing removed or modified files from linux-$kver-$libre.tar
 diff -rq linux-$kver linux-$kver-$libre |
 sed -n "
-  s,^Only in \(linux-$kver/.*\): \(.*\),\1/\2,p;
-  s,^Files \(linux-$kver/.*\) and libre-\1 differ,\1,p;
+  s,^Only in \\(linux-$kver\\(/.*\\)\\?\\): \\(.*\\),\1/\3,p;
+  s,^Files \\(linux-$kver\\)/\\(.*\\) and \\1-$libre/\\2 differ,\\1/\\2,p;
 " |
 xargs tar --delete -f linux-$kver-$libre.tar
 
@@ -180,8 +203,8 @@ mv linux-$kver orig-linux-$kver
 mv linux-$kver-$libre linux-$kver
 diff -rq orig-linux-$kver linux-$kver |
 sed -n "
-  s,^Files orig-\(linux-$kver/.*\) and \1 differ,\1,p;
-  s,^Only in \(linux-$kver/.*\): \(.*\),\1/\2,p;
+  s,^Files orig-\\(linux-$kver/.*\\) and \\1 differ,\\1,p;
+  s,^Only in \\(linux-$kver\\(/.*\\)\\?\\): \\(.*\\),\\1/\\3,p;
 " |
 xargs tar --append -f linux-$kver-$libre.tar
 
@@ -189,17 +212,31 @@ echo Wiping out extracted trees
 rm -rf linux-$kver orig-linux-$kver
 
 echo Creating xdelta between linux-$kver.tar and linux-$kver-$libre.tar
-xdelta delta -0 linux-$kver.tar linux-$kver-$libre.tar linux-$kver-$libre.xdelta
+xdelta delta -0 linux-$kver.tar linux-$kver-$libre.tar linux-$kver-$libre.xdelta || : # xdelta returns nonzero on success
 
-echo Compressing linux-$kver-$libre.tar
+echo Compressing linux-$kver-$libre.tar and linux-$kver-$libre.xdelta
 rm -f linux-$kver.tar
+lzip -k9 linux-$kver-$libre.tar
 bzip2 -9 linux-$kver-$libre.tar
+if test -f linux-$kver-$libre.xdelta; then
+  lzip -k9 linux-$kver-$libre.xdelta
+  bzip2 -9 linux-$kver-$libre.xdelta
+fi
 
 trap "status=$?; (exit $status); exit" 0 1 2 15
 
 echo Done except for signing, feel free to interrupt
-gpg -a --detach-sign linux-$kver-$libre.tar.bz2
-mv linux-$kver-$libre.tar.bz2.asc linux-$kver-$libre.tar.bz2.sign
+for f in \
+  linux-$kver-$libre.tar.bz2 \
+  linux-$kver-$libre.tar.lz \
+  linux-$kver-$libre.xdelta.bz2 \
+  linux-$kver-$libre.xdelta.lz \
+; do
+  if test -f $f; then
+    gpg -a --detach-sign $f
+    mv $f.asc $f.sign
+  fi
+done
 
 echo All set, please review linux-$kver-$libre.patch